import { codec, // Codec with XRP alphabet
encodeSeed, // Encode entropy as a "seed"
decodeSeed, // Decode a seed into an object with its version, type, and bytes
encodeAccountID, // Encode bytes as a classic address (r...)
decodeAccountID, // Decode a classic address to its raw bytes
encodeNodePublic, // Encode bytes to XRP Ledger node public key format
decodeNodePublic, // Decode an XRP Ledger node public key into its raw bytes
isValidAddress } from './xrp-codec';
declare function encodeXAddress(classicAddress: string, tag: number | false, test: boolean): string;
declare function decodeXAddress(xAddress: string): {
    classicAddress: string;
    tag: number | false;
    test: boolean;
};
declare function isValidXAddress(xAddress: string): boolean;
export { codec, // Codec with XRP alphabet
encodeSeed, // Encode entropy as a "seed"
decodeSeed, // Decode a seed into an object with its version, type, and bytes
encodeAccountID, // Encode bytes as a classic address (r...)
decodeAccountID, // Decode a classic address to its raw bytes
encodeNodePublic, // Encode bytes to XRP Ledger node public key format
decodeNodePublic, // Decode an XRP Ledger node public key into its raw bytes
isValidAddress, // Check whether a classic address (r...) is valid
encodeXAddress, // Encode classic address and optional tag to X-address
decodeXAddress, // Decode X-address to classic address and optional tag
isValidXAddress };
