"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("./index");
const testCases = [
    [
        'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf',
        false,
        'XVLhHMPHU98es4dbozjVtdWzVrDjtV5fdx1mHp98tDMoQXb',
        'TVE26TYGhfLC7tQDno7G8dGtxSkYQn49b3qD26PK7FcGSKE'
    ],
    [
        'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf',
        0,
        'XVLhHMPHU98es4dbozjVtdWzVrDjtV8AqEL4xcZj5whKbmc',
        'TVE26TYGhfLC7tQDno7G8dGtxSkYQnSy8RHqGHoGJ59spi2'
    ],
    [
        'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf',
        1,
        'XVLhHMPHU98es4dbozjVtdWzVrDjtV8xvjGQTYPiAx6gwDC',
        'TVE26TYGhfLC7tQDno7G8dGtxSkYQnSz1uDimDdPYXzSpyw'
    ],
    [
        'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf',
        2,
        'XVLhHMPHU98es4dbozjVtdWzVrDjtV8zpDURx7DzBCkrQE7',
        'TVE26TYGhfLC7tQDno7G8dGtxSkYQnTryP9tG9TW8GeMBmd'
    ],
    [
        'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf',
        32,
        'XVLhHMPHU98es4dbozjVtdWzVrDjtVoYiC9UvKfjKar4LJe',
        'TVE26TYGhfLC7tQDno7G8dGtxSkYQnT2oqaCDzMEuCDAj1j'
    ],
    [
        'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf',
        276,
        'XVLhHMPHU98es4dbozjVtdWzVrDjtVoKj3MnFGMXEFMnvJV',
        'TVE26TYGhfLC7tQDno7G8dGtxSkYQnTMgJJYfAbsiPsc6Zg'
    ],
    [
        'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf',
        65591,
        'XVLhHMPHU98es4dbozjVtdWzVrDjtVozpjdhPQVdt3ghaWw',
        'TVE26TYGhfLC7tQDno7G8dGtxSkYQn7ryu2W6njw7mT1jmS'
    ],
    [
        'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf',
        16781933,
        'XVLhHMPHU98es4dbozjVtdWzVrDjtVqrDUk2vDpkTjPsY73',
        'TVE26TYGhfLC7tQDno7G8dGtxSkYQnVsw45sDtGHhLi27Qa'
    ],
    [
        'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf',
        4294967294,
        'XVLhHMPHU98es4dbozjVtdWzVrDjtV1kAsixQTdMjbWi39u',
        'TVE26TYGhfLC7tQDno7G8dGtxSkYQnX8tDFQ53itLNqs6vU'
    ],
    [
        'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf',
        4294967295,
        'XVLhHMPHU98es4dbozjVtdWzVrDjtV18pX8yuPT7y4xaEHi',
        'TVE26TYGhfLC7tQDno7G8dGtxSkYQnXoy6kSDh6rZzApc69'
    ],
    [
        'rPEPPER7kfTD9w2To4CQk6UCfuHM9c6GDY',
        false,
        'XV5sbjUmgPpvXv4ixFWZ5ptAYZ6PD2gYsjNFQLKYW33DzBm',
        'TVd2rqMkYL2AyS97NdELcpeiprNBjwLZzuUG5rZnaewsahi'
    ],
    [
        'rPEPPER7kfTD9w2To4CQk6UCfuHM9c6GDY',
        0,
        'XV5sbjUmgPpvXv4ixFWZ5ptAYZ6PD2m4Er6SnvjVLpMWPjR',
        'TVd2rqMkYL2AyS97NdELcpeiprNBjwRQUBetPbyrvXSTuxU'
    ],
    [
        'rPEPPER7kfTD9w2To4CQk6UCfuHM9c6GDY',
        13371337,
        'XV5sbjUmgPpvXv4ixFWZ5ptAYZ6PD2qwGkhgc48zzcx6Gkr',
        'TVd2rqMkYL2AyS97NdELcpeiprNBjwVUDvp3vhpXbNhLwJi'
    ]
];
[false, true].forEach(isTestAddress => {
    const network = isTestAddress ? ' (test)' : ' (main)';
    for (const i in testCases) {
        const testCase = testCases[i];
        const classicAddress = testCase[0];
        const tag = testCase[1] !== false ? testCase[1] : false;
        const xAddress = isTestAddress ? testCase[3] : testCase[2];
        test(`Converts ${classicAddress}${tag ? ':' + tag : ''} to ${xAddress}${network}`, () => {
            const myXAddress = index_1.encodeXAddress(classicAddress, tag, isTestAddress);
            expect(myXAddress).toBe(xAddress);
            const myClassicAddress = index_1.decodeXAddress(xAddress);
            expect(myClassicAddress).toEqual({
                classicAddress,
                tag,
                test: isTestAddress
            });
            expect(index_1.isValidXAddress(xAddress)).toBe(true);
        });
    }
    {
        const MAX_32_BIT_UNSIGNED_INT = 4294967295;
        const classicAddress = 'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf';
        const tag = MAX_32_BIT_UNSIGNED_INT + 1;
        test(`Converting ${classicAddress}:${tag}${network} throws`, () => {
            expect(() => {
                index_1.encodeXAddress(classicAddress, tag, isTestAddress);
            }).toThrowError(new Error('Invalid tag'));
        });
    }
    {
        const classicAddress = 'r';
        test(`Invalid classic address: Converting ${classicAddress}${network} throws`, () => {
            expect(() => {
                index_1.encodeXAddress(classicAddress, false, isTestAddress);
            }).toThrowError(new Error('invalid_input_size: decoded data must have length >= 5'));
        });
    }
});
{
    const xAddress = 'XVLhHMPHU98es4dbozjVtdWzVrDjtV5fdx1mHp98tDMoQXa';
    test(`Invalid X-address (bad checksum): Converting ${xAddress} throws`, () => {
        expect(() => {
            index_1.decodeXAddress(xAddress);
        }).toThrowError(new Error('checksum_invalid'));
    });
}
{
    const xAddress = 'dGzKGt8CVpWoa8aWL1k18tAdy9Won3PxynvbbpkAqp3V47g';
    test(`Invalid X-address (bad prefix): Converting ${xAddress} throws`, () => {
        expect(() => {
            index_1.decodeXAddress(xAddress);
        }).toThrowError(new Error('Invalid X-address: bad prefix'));
    });
}
test(`Invalid X-address (64-bit tag) throws`, () => {
    expect(() => {
        // Encoded from:
        // {
        //   classicAddress: 'rGWrZyQqhTp9Xu7G5Pkayo7bXjH4k4QYpf',
        //   tag: MAX_32_BIT_UNSIGNED_INT + 1
        // }
        index_1.decodeXAddress('XVLhHMPHU98es4dbozjVtdWzVrDjtV18pX8zeUygYrCgrPh');
    }).toThrowError('Unsupported X-address');
});
test(`isValidXAddress returns false for invalid X-address`, () => {
    expect(index_1.isValidXAddress('XVLhHMPHU98es4dbozjVtdWzVrDjtV18pX8zeUygYrCgrPh')).toBe(false);
});
//# sourceMappingURL=index.test.js.map